#!/usr/local/bin/perl
# Show a form for editing a filesystem or adding one

require './zones-lib.pl';
&ReadParse();
$zinfo = &get_zone($in{'zone'});
$zinfo || &error($text{'edit_egone'});
&ui_print_header(&zone_title($in{'zone'}),
		 $in{'new'} ? $text{'fs_title1'} : $text{'fs_title2'}, "", "fs");
if (!$in{'new'}) {
	# Find the filesystem object
	($fs) = grep { $_->{'dir'} eq $in{'dir'} } @{$zinfo->{'fs'}};
	$fs || &error($text{'fs_egone'});
	$mount = &get_active_mount($zinfo, $fs);
	}

$type = $in{'type'} || $fs->{'type'};
print &ui_form_start("save_fs.cgi", "post");
print &ui_hidden("zone", $in{'zone'});
print &ui_hidden("new", $in{'new'});
print &ui_hidden("old", $in{'dir'});
print &ui_hidden("type", $type);
print &ui_table_start($text{'fs_header'}, undef, 2);

print &ui_table_row($text{'fs_type'},
		    &mount::fstype_name($type)." (".uc($type).")");

if (!$in{'new'}) {
	if ($mount) {
		($total, $free) = &mount::disk_space($mount->[2], $mount->[0]);
		print &ui_table_row($text{'fs_status'},
			$total ? &text('fs_mountedsp', &nice_size($total*1024),
						       &nice_size($free*1024)) :
			         $text{'fs_mounted'});
		}
	else {
		print &ui_table_row($text{'fs_status'}, $text{'fs_unmounted'});
		}
	}
else {
	print &ui_table_row($text{'fs_mount'},
		      &ui_yesno_radio("mount", $zinfo->{'status'} eq 'running' ?
					       1 : 0));
	}

print &ui_table_row($text{'fs_dir'},
		    &ui_textbox("dir", $fs->{'dir'}, 40));

if (&indexof($type, &mount::list_fstypes()) >= 0) {
	# A supported filesystem, which means we can show nice options
	print &ui_table_row($text{'fs_special'},
		    "<table border width=100%><tr><td><table>".
		    &capture_function_output(\&mount::generate_location, $type,
					     $fs->{'special'}).
		    "</table></td></tr></table>");

	&mount::parse_options($type, $fs->{'options'});
	print &ui_table_row($text{'fs_options'},
		    "<table border width=100%><tr><td><table>".
		    &capture_function_output(\&mount::generate_options, $type,
					     $in{'new'} ? 1 : 0).
		    "</table></td></tr></table>");
	}
else {
	# Un-supported, so show just text fields
	print &ui_table_row($text{'fs_special'},
			    &ui_textbox("special", $fs->{'special'}, 40));

	print &ui_table_row($text{'fs_options'},
			    &ui_textbox("options", $fs->{'options'}, 40));
	}

print &ui_table_end();
print &ui_form_end([ $in{'new'} ? 
	( [ "create", $text{'create'} ] ) :
	( [ "save", $text{'save'} ], [ "delete", $text{'delete'} ] ) ] );

&ui_print_footer("edit_zone.cgi?zone=$in{'zone'}", $text{'edit_return'});

