#!/usr/local/bin/perl
# Shows the details of one zone, with links to make changes

require './zones-lib.pl';
&ReadParse();
$zinfo = &get_zone($in{'zone'});
$zinfo || &error($text{'edit_egone'});
&ui_print_header(&zone_title($in{'zone'}), $text{'edit_title'}, "", "edit");

# Show general information
print &ui_form_start("save_zone.cgi");
print &ui_hidden("zone", $in{'zone'}),"\n";
print &ui_table_start($text{'edit_common'}, "width=100%", 4);

@tds = ( "width=25%", "width=25%" );
print &ui_table_row($text{'edit_name'}, "<tt>$in{'zone'}</tt>", 1, \@tds);
print &ui_table_row($text{'edit_status'}, &nice_status($zinfo->{'status'}), 1, \@tds);
print &ui_table_row($text{'edit_zonepath'}, "<tt>$zinfo->{'zonepath'}</tt>", 3);
print &ui_table_row($text{'edit_autoboot'},
		    &ui_select("autoboot", $zinfo->{'autoboot'},
			       [ [ "true", $text{'yes'} ],
				 [ "false", $text{'no'} ] ]), 1, \@tds);
print &ui_table_row($text{'edit_pool'},
		    &pool_input("pool", $zinfo->{'pool'}), 1, \@tds);

@actions = &zone_status_actions($zinfo, 1);
print &ui_table_end();
print &ui_form_end([ [ "save", $text{'save'} ], undef,
		     @actions ? ( @actions, undef ) : ( ),
		     [ "delete", $text{'edit_delete'} ] ]);

# Show network interfaces
print &ui_table_start($text{'edit_net'}, "width=100%", 2);
print "<td colspan=2>\n";
if (@{$zinfo->{'net'}}) {
	print &ui_columns_start([ $text{'edit_netaddress'},
				  $text{'edit_netname'},
				  $text{'edit_netmask'},
				  $text{'edit_netbroad'} ], "100%");
	foreach $net (@{$zinfo->{'net'}}) {
		$active = &get_active_interface($zinfo, $net);
		($address, $netmask) = &get_address_netmask($net, $active);
		print &ui_columns_row([
			"<a href='edit_net.cgi?zone=$in{'zone'}&address=$net->{'address'}'>$address</a>",
			$active->{'fullname'} || $text{'edit_netdown'},
			$netmask,
			$active->{'broadcast'} ]);
		}
	print &ui_columns_end();
	}
else {
	print "<b>$text{'edit_netnone'}</b><p>\n";
	}
print "<a href='edit_net.cgi?zone=$in{'zone'}&new=1'>$text{'edit_netadd'}</a></td>\n";
print &ui_table_end(),"<p>\n";

# Show package directories
print &ui_table_start($text{'edit_pkg'}, "width=100%", 2);
print "<td colspan=2>\n";
if ($zinfo->{'status'} eq 'configured') {
	# Can edit package directories
	if (@{$zinfo->{'inherit-pkg-dir'}}) {
		print &ui_columns_start([ $text{'edit_pkgdir'} ], "100%");
		foreach $pkg (@{$zinfo->{'inherit-pkg-dir'}}) {
			print &ui_columns_row([
				"<a href='edit_pkg.cgi?zone=$in{'zone'}&dir=$pkg->{'dir'}'>$pkg->{'dir'}</a>",
				]);
			}
		print &ui_columns_end();
		}
	else {
		print "<b>$text{'edit_pkgnone'}</b><p>\n";
		}
	print "<a href='edit_pkg.cgi?zone=$in{'zone'}&new=1'>$text{'edit_pkgadd'}</a>\n";
	}
else {
	# Not installed, so cannot add .. just list them
	foreach $pkg (@{$zinfo->{'inherit-pkg-dir'}}) {
		print "<tt>$pkg->{'dir'}</tt><br>\n";
		}
	print "<b>$text{'edit_pkgcannot'}</b><br>\n";
	}
print "</td>\n";
print &ui_table_end(),"<p>\n";

# Show other filesystems
print &ui_table_start($text{'edit_fs'}, "width=100%", 2);
print &ui_form_start("edit_fs.cgi");
print &ui_hidden("new", 1);
print &ui_hidden("zone", $in{'zone'});
print "<td colspan=2>\n";
if (@{$zinfo->{'fs'}}) {
	print &ui_columns_start([ $text{'edit_fsdir'},
				  $text{'edit_fsspecial'},
				  $text{'edit_fstype'},
				  $text{'edit_fsmounted'} ], "100%");
	foreach $fs (@{$zinfo->{'fs'}}) {
		print &ui_columns_row([
			"<a href='edit_fs.cgi?zone=$in{'zone'}&dir=$fs->{'dir'}'>$fs->{'dir'}</a>",
			&mount::device_name($fs->{'special'}),
			&mount::fstype_name($fs->{'type'}),
			&get_active_mount($zinfo, $fs) ?
				$text{'yes'} : $text{'no'},
			]);
		}
	print &ui_columns_end();
	}
else {
	print "<b>$text{'edit_fsnone'}</b><p>\n";
	}
print &ui_submit($text{'edit_fsadd'}),"\n";
print &ui_select("type", "ufs",
	 [ map { [ $_, &mount::fstype_name($_) ] } &list_filesystems() ]);
print "</td>\n";
print &ui_form_end();
print &ui_table_end(),"<p>\n";

# Show resource controls
print &ui_table_start($text{'edit_rctl'}, "width=100%", 2);
print "<td colspan=2>\n";
if (@{$zinfo->{'rctl'}}) {
	print &ui_columns_start([ $text{'edit_rctlname'},
				  $text{'edit_rctlpriv'},
				  $text{'edit_rctllimit'},
				  $text{'edit_rctlaction'}, ], "100%");
	foreach $rctl (@{$zinfo->{'rctl'}}) {
		@values = split(/\0/, $rctl->{'value'});
		local (@privs, @limits, @actions);
		foreach $v (@values) {
			($priv, $limit, $action) = &get_rctl_value($v);
			push(@privs, $text{'rctl_'.$priv});
			push(@limits, $limit);
			push(@actions, $text{'rctl_'.$action});
			}
		print &ui_columns_row([
			"<a href='edit_rctl.cgi?zone=$in{'zone'}&name=$rctl->{'name'}'>$rctl->{'name'}</a>",
			join("<br>", @privs),
			join("<br>", @limits),
			join("<br>", @actions),
			], [ "valign=top"]);
		}
	print &ui_columns_end();
	}
else {
	print "<b>$text{'edit_rctlnone'}</b><p>\n";
	}
print "<a href='edit_rctl.cgi?zone=$in{'zone'}&new=1'>$text{'edit_rctladd'}</a>\n";
print "</td>\n";
print &ui_table_end(),"<p>\n";

# Show generic attributes
print &ui_table_start($text{'edit_attr'}, "width=100%", 2);
print "<td colspan=2>\n";
if (@{$zinfo->{'attr'}}) {
	print &ui_columns_start([ $text{'edit_attrname'},
				  $text{'edit_attrtype'},
				  $text{'edit_attrvalue'}, ], "100%");
	foreach $attr (@{$zinfo->{'attr'}}) {
		print &ui_columns_row([
			"<a href='edit_attr.cgi?zone=$in{'zone'}&name=$attr->{'name'}'>$attr->{'name'}</a>",
			$text{'attr_'.$attr->{'type'}},
			$attr->{'value'},
			]);
		}
	print &ui_columns_end();
	}
else {
	print "<b>$text{'edit_attrnone'}</b><p>\n";
	}
print "<a href='edit_attr.cgi?zone=$in{'zone'}&new=1'>$text{'edit_attradd'}</a>\n";
print "</td>\n";
print &ui_table_end(),"<p>\n";

&ui_print_footer("", $text{'index_return'});

