#!/usr/local/bin/perl
# Shows all zones, with links to add more

require './zones-lib.pl';
&ui_print_header(undef, $module_info{'desc'}, "", "intro", 1, 1);

# Check if zones are installed
if (!&has_command("zoneadm")) {
	&ui_print_endpage(&text('index_ecmd', "<tt>zoneadm</tt>"));
	}

# Make sure this is the global zone!
$zn = &get_current_zone();
if ($zn ne "global") {
	&ui_print_endpage(&text('index_eglobal', "<tt>$zn</tt>"));
	}

@zones = sort { $a->{'name'} cmp $b->{'name'} } &list_zones();
if (!@zones) {
	print "<b>$text{'index_none'}</b><p>\n";
	}
elsif ($config{'list_mode'}) {
	# Show as list
	print "<a href='create_form.cgi'>$text{'index_add'}</a><br>\n";
	&print_zones_list(\@zones);
	}
else {
	# Show as icons
	print "<a href='create_form.cgi'>$text{'index_add'}</a><br>\n";
	@links = map { "edit_zone.cgi?zone=$_->{'name'}" } @zones;
	@titles = map { "<tt>$_->{'name'}</tt> (".
			&nice_status($_->{'status'}).")" } @zones;
	@icons = map { "images/zone.gif" } @zones;
	&icons_table(\@links, \@titles, \@icons, 4);
	}
print "<a href='create_form.cgi'>$text{'index_add'}</a><br>\n";

&ui_print_footer("/", $text{'index'});

