#!/usr/local/bin/perl
# Update, add or delete a generic attribute

require './zones-lib.pl';
&ReadParse();
$zinfo = &get_zone($in{'zone'});
$zinfo || &error($text{'edit_egone'});
if (!$in{'new'}) {
	# Find the filesystem object
	($attr) = grep { $_->{'name'} eq $in{'old'} } @{$zinfo->{'attr'}};
	$attr || &error($text{'attr_egone'});
	}
else {
	$attr = { 'keytype' => 'attr' };
	}

if ($in{'delete'}) {
	# Just remove this attribute
	&delete_zone_object($zinfo, $attr);
	}
else {
	# Validate inputs
	&error_setup($text{'attr_err'});
	$in{'name'} =~ /^\S+$/ || &error($text{'attr_ename'});
	$attr->{'name'} = $in{'name'};
	$attr->{'type'} = $in{'type'};
	if ($attr->{'type'} eq 'int') {
		$in{'value'} =~ /^\-?\d+$/ || &error($text{'attr_eint'});
		}
	elsif ($attr->{'type'} eq 'uint') {
		$in{'value'} =~ /^\d+$/ || &error($text{'attr_euint'});
		}
	elsif ($attr->{'type'} eq 'boolean') {
		$in{'value'} eq "true" || $in{'value'} eq "false" ||
			&error($text{'attr_uboolean'});
		}
	$attr->{'value'} = $in{'value'};
	&find_clash($zinfo, $attr) && &error($text{'attr_eclash'});

	# Save the attribute
	if ($in{'new'}) {
		&create_zone_object($zinfo, $attr);
		}
	else {
		&modify_zone_object($zinfo, $attr);
		}
	}

&webmin_log($in{'new'} ? "create" : $in{'delete'} ? "delete" : "modify",
	    "attr", $in{'old'} || $attr->{'name'}, $attr);
&redirect("edit_zone.cgi?zone=$in{'zone'}");

