#!/usr/local/bin/perl
# Update, add or delete a filesystem

require './zones-lib.pl';
&ReadParse();
$zinfo = &get_zone($in{'zone'});
$zinfo || &error($text{'edit_egone'});
if (!$in{'new'}) {
	# Find the filesystem object
	($fs) = grep { $_->{'dir'} eq $in{'old'} } @{$zinfo->{'fs'}};
	$fs || &error($text{'fs_egone'});
	$mount = &get_active_mount($zinfo, $fs);
	}
else {
	$fs = { 'keytype' => 'fs',
		'type' => $in{'type'} };
	}

if ($in{'delete'}) {
	# Just remove this filesystem
	&delete_zone_object($zinfo, $fs);

	# Attempt to un-mount it (if mounted)
	if ($mount) {
		&error_setup($text{'fs_err3'});
		&mount::unmount_dir(@$mount);
		}
	}
else {
	# Validate inputs
	&error_setup($text{'fs_err'});
	$in{'dir'} =~ /^\/\S/ || &error($text{'fs_edir'});
	$fs->{'dir'} = $in{'dir'};
	if (&indexof($in{'type'}, &mount::list_fstypes()) >= 0) {
		# Parse friendly filesystem forms
		%mount::in = %in;
		$fs->{'special'} = &mount::check_location($in{'type'});
		&mount::check_options($in{'type'});
		$fs->{'options'} = &mount::join_options($in{'type'});
		}
	else {
		# Just use user-entered device and options
		$in{'special'} =~ /\S/ || &error($text{'fs_especial'});
		$fs->{'special'} = $in{'special'};
		$in{'options'} =~ /^\S*$/ || &error($text{'fs_eoptions'});
		$fs->{'options'} = $in{'options'};
		}
	if ($fs->{'special'} =~ /^\/dev\/dsk\/(.*)$/) {
		$fs->{'raw'} = "/dev/rdsk/$1";
		}
	&find_clash($zinfo, $fs) && &error($text{'fs_eclash'});

	# Save the filesystem settings
	$mp = &get_zone_root($zinfo).$fs->{'dir'};
	if ($in{'new'}) {
		&create_zone_object($zinfo, $fs);

		# Attempt to mount it
		if ($in{'mount'}) {
			&error_setup($text{'fs_err2'});
			&system_logged("mkdir -p ".quotemeta($mp));
			&mount::mount_dir($mp,
					  $fs->{'special'},
					  $fs->{'type'},
					  $fs->{'options'});
			}
		}
	else {
		&modify_zone_object($zinfo, $fs);

		# Attempt to re-mount it
		if ($mount) {
			&error_setup($text{'fs_err4'});
			&mount::unmount_dir(@$mount);
			if ($fs->{'dir'} ne $in{'old'}) {
				&system_logged("mkdir -p ".quotemeta($mp));
				}
			&mount::mount_dir($mp,
					  $fs->{'special'},
					  $fs->{'type'},
					  $fs->{'options'});
			}
		}
	}

&webmin_log($in{'new'} ? "create" : $in{'delete'} ? "delete" : "modify",
	    "fs", $in{'old'} || $fs->{'dir'}, $fs);
&redirect("edit_zone.cgi?zone=$in{'zone'}");

