#!/usr/local/bin/perl
# Update, add or delete a network interface

require './zones-lib.pl';
&ReadParse();
$zinfo = &get_zone($in{'zone'});
$zinfo || &error($text{'edit_egone'});
if (!$in{'new'}) {
	# Find the network object
	($net) = grep { $_->{'address'} eq $in{'old'} } @{$zinfo->{'net'}};
	$net || &error($text{'net_egone'});
	$active = &get_active_interface($zinfo, $net);
	}
else {
	$net = { 'keytype' => 'net' };
	}

if ($in{'delete'}) {
	# Just remove this network
	&delete_zone_object($zinfo, $net);
	&net::deactivate_interface($active) if ($active);
	}
else {
	# Validate inputs
	&error_setup($text{'net_err'});
	&check_ipaddress($in{'address'}) || &error($text{'net_eaddress'});
	if (!$in{'netmask_def'}) {
		&check_ipaddress($in{'netmask'}) ||
			&error($text{'net_enetmask'});
		$cidr = &net::mask_to_prefix($in{'netmask'});
		$net->{'address'} = $in{'address'}."/".$cidr;
		}
	else {
		$net->{'address'} = $in{'address'};
		}
	$net->{'physical'} = $in{'physical'};
	&find_clash($zinfo, $net) && &error($text{'net_eclash'});

	# Create or update the real interface
	if ($in{'new'}) {
		local $vmax = int($net::min_virtual_number);
		local $a;
		foreach $a (&net::active_interfaces()) {
			$vmax = $a->{'virtual'}
				if ($a->{'name'} eq $in{'physical'} &&
				    $a->{'virtual'} > $vmax);
			}
		$active = { 'name' => $in{'physical'},
			    'virtual' => $vmax+1,
			    'fullname' => $in{'physical'}.":".($vmax+1),
			    'zone' => $in{'zone'},
			    'up' => 1 };
		}
	if ($active) {
		$active->{'address'} = $in{'address'};
		if ($in{'netmask_def'}) {
			$active->{'netmask'} =
				&net::automatic_netmask($in{'address'});
			}
		else {
			$active->{'netmask'} = $in{'netmask'};
			}
		$active->{'broadcast'} = &net::compute_broadcast(
			$active->{'address'}, $active->{'netmask'});
		$active->{'zone'} = $in{'zone'};
		}

	# Save the zone settings
	if ($in{'new'}) {
		&create_zone_object($zinfo, $net);
		if ($zinfo->{'status'} eq 'running') {
			&net::activate_interface($active);
			}
		}
	else {
		&modify_zone_object($zinfo, $net);
		if ($active) {
			&net::activate_interface($active);
			}
		}
	}

&webmin_log($in{'new'} ? "create" : $in{'delete'} ? "delete" : "modify",
	    "net", $in{'old'} || $net->{'address'}, $net);
&redirect("edit_zone.cgi?zone=$in{'zone'}");

