#!/usr/local/bin/perl
# Update, add or delete a resource control

require './zones-lib.pl';
&ReadParse();
$zinfo = &get_zone($in{'zone'});
$zinfo || &error($text{'edit_egone'});
if (!$in{'new'}) {
	# Find the rctl object
	($rctl) = grep { $_->{'name'} eq $in{'old'} } @{$zinfo->{'rctl'}};
	$rctl || &error($text{'rctl_egone'});
	}
else {
	$rctl = { 'keytype' => 'rctl' };
	}

if ($in{'delete'}) {
	# Just remove this resource control
	&delete_zone_object($zinfo, $rctl);
	}
else {
	# Validate inputs
	&error_setup($text{'rctl_err'});
	$rctl->{'name'} = $in{'name'};
	@values = ( );
	for($i=0; defined($priv = $in{"priv_$i"}); $i++) {
		next if (!$priv);
		$limit = $in{"limit_$i"};
		$limit =~ /^\d+/ || &error(&text('rctl_elimit', $i+1));
		$action = $in{"action_$i"};
		if ($action eq "signal") {
			$in{"signal_$i"} || &error(&text('rctl_esignal', $i+1));
			$action .= "=".$in{"signal_$i"};
			}
		push(@values, "(priv=$priv,limit=$limit,action=$action)");
		}
	@values || &error($text{'rctl_evalues'});
	$rctl->{'value'} = join("\0", @values);
	&find_clash($zinfo, $rctl) && &error($text{'rctl_eclash'});

	# Save the rctl
	if ($in{'new'}) {
		&create_zone_object($zinfo, $rctl);
		}
	else {
		&modify_zone_object($zinfo, $rctl);
		}
	}

&webmin_log($in{'new'} ? "create" : $in{'delete'} ? "delete" : "modify",
	    "rctl", $in{'old'} || $rctl->{'name'}, $rctl);
&redirect("edit_zone.cgi?zone=$in{'zone'}");

