#!/usr/local/bin/perl
# Update, reboot or delete a zone

require './zones-lib.pl';
&ReadParse();
$zinfo = &get_zone($in{'zone'});
$zinfo || &error($text{'edit_egone'});

if ($in{'reboot'}) {
	# Reboot after asking for confirmation
	if (&ask_for_confirm("reboot")) {
		&error_setup($text{'reboot_err'});
		&run_zone_command($zinfo, "reboot");
		&webmin_log("reboot", "zone", $in{'zone'});
		&redirect($in{'list'} ? "" : "edit_zone.cgi?zone=$in{'zone'}");
		}
	}
elsif ($in{'boot'}) {
	# Just bootup now
	&error_setup($text{'boot_err'});
	&run_zone_command($zinfo, "boot");
	&webmin_log("boot", "zone", $in{'zone'});
	&redirect($in{'list'} ? "" : "edit_zone.cgi?zone=$in{'zone'}");
	}
elsif ($in{'halt'}) {
	# Shutdown after asking for confirmation
	if (&ask_for_confirm("halt")) {
		&error_setup($text{'halt_err'});
		&run_zone_command($zinfo, "halt");
		&webmin_log("halt", "zone", $in{'zone'});
		&redirect($in{'list'} ? "" : "edit_zone.cgi?zone=$in{'zone'}");
		}
	}
elsif ($in{'install'}) {
	# Install system now
	&ui_print_unbuffered_header(&zone_title($in{'zone'}), $text{'install_title'}, "");
	print "$text{'create_installing'}\n";
	print "<pre>";
	$ok = &output_zone_command($zinfo, "install", STDOUT, 1);
	print "</pre>";
	if ($ok) {
		print "$text{'create_done'}<p>\n";
		$sysidcfg = &zone_sysidcfg_file($in{'zone'});
		if (-r $sysidcfg) {
			# Move sysidcfg into place, for later boot
			&system_logged("mv $sysidcfg $zinfo->{'zonepath'}/root/etc/sysidcfg");
			}
		&config_zone_nfs($zinfo);
		&webmin_log("install", "zone", $in{'zone'});
		}
	else {
		print "$text{'create_failed'}<p>\n";
		}
	if ($in{'list'}) {
		&ui_print_footer("", $text{'index_return'});
		}
	else {
		&ui_print_footer("edit_zone.cgi?zone=$in{'zone'}",
				 $text{'edit_return'});
		}
	}
elsif ($in{'delete'}) {
	# Delete after confirming
	if (&ask_for_confirm("delete")) {
		&error_setup($text{'delete_err'});
		if ($zinfo->{'status'} ne 'configured') {
			if ($zinfo->{'status'} ne 'installed') {
				&run_zone_command($zinfo, "halt");
				}
			&run_zone_command($zinfo, "uninstall -F");
			}
		&delete_zone($zinfo);
		unlink(&zone_sysidcfg_file($in{'zone'}));
		&webmin_log("delete", "zone", $in{'zone'});
		&redirect("");
		}
	}
elsif ($in{'uninstall'}) {
	# Un-install after confirming
	if (&ask_for_confirm("uninstall")) {
		&error_setup($text{'uninstall_err'});
		&run_zone_command($zinfo, "uninstall -F");
		&webmin_log("uninstall", "zone", $in{'zone'});
		&redirect($in{'list'} ? "" : "edit_zone.cgi?zone=$in{'zone'}");
		}
	}
elsif ($in{'wupgrade'} || $in{'winstall'}) {
	# Install system now
	&ui_print_unbuffered_header(&zone_title($in{'zone'}), $text{'webmin_title'}, "");
	print "$text{'create_webmining'}<p>\n";
	$script = &get_zone_root($zinfo)."/tmp/install-webmin";
	$err = &create_webmin_install_script($zinfo, $script);
	if ($err) {
		print &text('created_wfailed', $err),"<p>\n";
		}
	else {
		print "<pre>";
		($out, $ex) = &run_in_zone($zinfo, "/tmp/install-webmin");
		print $out;
		print "</pre>";
		if (!$ex) {
			print "$text{'create_done'}<p>\n";
			}
		else {
			print "$text{'create_failed'}<p>\n";
			}
		}
	&ui_print_footer("edit_zone.cgi?zone=$in{'zone'}",
			 $text{'edit_return'});
	}
elsif ($in{'webmin'}) {
	# Redirect to Webmin in the zone
	$url = &zone_running_webmin($zinfo);
	&error($text{'save_ewebmin'}) if (!$url);
	&redirect($url);
	}
else {
	# Just update autoboot and pool
	&error_setup($text{'save_err'});
	$in{'pool_def'} || $in{'pool'} =~ /^\S+$/ ||
		&error($text{'save_epool'});
	&set_zone_variable($zinfo, "autoboot", $in{'autoboot'});
	&set_zone_variable($zinfo, "pool",
			   $in{'pool_def'} ? undef : $in{'pool'});
	&webmin_log("save", "zone", $in{'zone'});
	&redirect("");
	}

# ask_for_confirm(action)
sub ask_for_confirm
{
local ($action) = @_;
if (!$in{'confirm'}) {
	&ui_print_header(&zone_title($in{'zone'}), $text{$action.'_title'}, "");
	print &ui_form_start("save_zone.cgi", "post");
	foreach $i (keys %in) {
		print &ui_hidden($i, $in{$i});
		}
	print "<center>",&text($action.'_rusure',
			       "<tt>$in{'zone'}</tt>"),"<p>\n";
	print &ui_submit($text{'edit_'.$action}, "confirm"),"</center>\n";
	if ($in{'list'}) {
		&ui_print_footer("", $text{'index_return'});
		}
	else {
		&ui_print_footer("edit_zone.cgi?zone=$in{'zone'}",
				 $text{'edit_return'});
		}
	return 0;
	}
return 1;
}
